<template>
    <div>

        <el-form :model="formData" :rules="formRules" ref="dataForm" label-width="120px">
            <el-row type="flex" justify="end" v-if="editType == 1">
              <el-button-group style="display: flex;margin-bottom: 15px; margin-right: 50px">
                <el-button
                  v-show="!this.sysApprovalFlowConfig"
                  type="primary"
                  @click.native="saveOrder('3')"
                  :loading="passLoading"
                >审核通过
                </el-button
                >
                <el-button
                  v-show="!this.sysApprovalFlowConfig"
                  type="primary"
                  @click.native="saveOrder('4')"
                  :loading="noPassLoading"
                >审核拒绝
                </el-button
                >
                <el-button
                  v-show="this.sysApprovalFlowConfig"
                  type="primary"
                  @click.native="showApprovalFlowDetail()"
                >审核过程
                </el-button>
              </el-button-group>
            </el-row>

            <el-card style="margin-top: -5px;">
                <el-row>
                    <el-col  :span="11">
                        <el-form-item label="采购单号:"  prop="billNo">
                            <el-input v-model="formData.billNo" style="width: 90%" auto-complete="off" :disabled="true"></el-input>
                        </el-form-item>
                    </el-col>
                    <el-col :span="11">
                        <el-form-item label="创建时间:"  prop="createTime">
                            <el-date-picker
                                :disabled="true"
                                v-model="formData.createTime"
                                type="datetime"
                                placeholder="选择日期"
                                style="width: 90%"
                                :clearable="false"
                                value-format="yyyy-MM-dd HH:mm:ss"
                            >
                            </el-date-picker>
                        </el-form-item>
                    </el-col>
                </el-row>
              <el-row style="margin-top: -10px">
                <el-col :span="11">
                  <el-form-item label="紧急程度:" prop="emergency">
                    <el-select v-model="formData.emergency" :disabled="true" placeholder="请选择紧急程度" style="width: 90%" clearable>
                      <el-option label="正常" :value=1></el-option>
                      <el-option label="较急" :value=2></el-option>
                      <el-option label="特急" :value=3></el-option>
                    </el-select>
                  </el-form-item>
                </el-col>
                <el-col :span="11">
                  <el-form-item label="到货截止:" prop="arrivalTime">
                    <el-date-picker
                      :disabled="true"
                      v-model="formData.arrivalTime"
                      type="datetime"
                      placeholder="选择日期"
                      style="width: 90%"
                      :clearable="false"
                      value-format="yyyy-MM-dd HH:mm:ss"
                    >
                    </el-date-picker>
                  </el-form-item>
                </el-col>
              </el-row>
                <el-row>
                    <el-col :span="11">
                        <el-form-item label="采购仓库:"  prop="locStorageCode">
                            <el-select v-model="formData.invName" placeholder="采购仓库信息"  style="width: 90%"
                                       :disabled="true" clearable>
                                <el-option
                                    v-for="item in subInvList"
                                    :key="item.name"
                                    :label="item.name"
                                    :value="item.code">
                                    <span style="float: left">{{ item.name }}</span>
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                    <el-col :span="11">
                        <el-form-item label="审核说明:"  prop="billNo">
                            <el-input v-model="formData.auditRemark" style="width: 90%" auto-complete="off" type="textarea" autosize></el-input>
                        </el-form-item>
                    </el-col>
                </el-row>



                <el-row>
                    <el-col :span="11">
                        <el-form-item label="采购说明:"  prop="billNo">
                            <el-input v-model="formData.remark"   style="width: 90%":disabled="true" auto-complete="off" type="textarea" autosize></el-input>
                        </el-form-item>
                    </el-col>
<!--                    <el-col :span="11">-->
<!--                        <el-form-item>-->
<!--                            <el-checkbox v-model="formData.autoPurchase">是否生成采购入库单</el-checkbox>-->
<!--                        </el-form-item>-->
<!--                    </el-col>-->

                </el-row>
                <el-row  v-show="formData.autoPurchase">
                    <el-col :span="11">
                        <el-form-item label="入库仓库:"  prop="locStorageCode">
                            <el-select v-model="formData.targetSubInv" placeholder="入库仓库信息"  style="width: 90%" @change="targetInvChange" clearable>
                                <el-option
                                    v-for="item in tarSubList"
                                    :key="item.name"
                                    :label="item.name"
                                    :value="item.code">
                                    <span style="float: left">{{ item.name }}</span>
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                    <el-col :span="11">
                        <el-form-item label="入库单据类型:"  class="query-form-item" prop="targetBillAction">
                            <el-select v-model="formData.targetBillAction" placeholder="请选择单据类型"  style="width: 90%">
                                <el-option
                                    v-for="item in busTypes"
                                    :key="item.name"
                                    :label="item.name"
                                    :value="item.action">
                                    <span style="float: left">{{ item.name }}</span>
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>


                </el-row>
            </el-card>

            <el-card>
                <el-table v-loading="loading" :data="codeArray" style="width: 100%;" :row-class-name="tableRowClassName" border highlight-current-row max-height="300" height="300" ref="multipleTable">
                  <el-table-column label="序号" type="index" width="60"></el-table-column>
                  <el-table-column label="DI/物资编码" prop="nameCode"></el-table-column>
                  <el-table-column label="物资名称" prop="productName" show-overflow-tooltip="true"></el-table-column>
                  <el-table-column label="规格型号" prop="spec" show-overflow-tooltip="true"></el-table-column>
                  <el-table-column label="计量单位" prop="measname" show-overflow-tooltip="true" width="100"></el-table-column>
                  <el-table-column label="采购数量" prop="count"></el-table-column>
                  <el-table-column label="注册/备案号" prop="zczbhhzbapzbh"></el-table-column>
                  <el-table-column label="生产厂家" prop="manufactory"></el-table-column>
                  <el-table-column label="供应商" prop="supName"></el-table-column>
                </el-table>
            </el-card>
        </el-form>

        <el-dialog
            title="产品录入"
            :visible.sync="selectProductVisible"
            :close-on-click-modal="false"
            :close-on-press-escape="false"
            width="80%"
            v-if="selectProductVisible"
            :append-to-body='true'
        >
            <purPlanProducts
                :closeDialog="closeDialogC2"
                :data="thisData"
                :purType="1"
            ></purPlanProducts>
        </el-dialog>

      <el-dialog
        title="审批详情"
        :visible.sync="approvalFlowDetailVisible"
        width="80%"
        v-if="approvalFlowDetailVisible"
        @close='closeDialog'
        :close-on-click-modal="false"
        :close-on-press-escape="false"
        :before-close="handleClose"
      >
        <approvalFlowDetail
          :isChang="true"
          :closeDialog="closeDialog"
          :idQuery="idQuery"
        ></approvalFlowDetail>
      </el-dialog>


    </div>
</template>

<script>
import approvalFlowDetail from "@/components/ApprovalFlow/index";
import {getSysApprovalFlowConfig} from "@/api/basic/sysApprovalFlow";
import draggable from "vuedraggable";
import purPlanProducts from "@/views/purchase/purPlan/purOrderSelectProduct";
import {auditOrder, delApplyDetail, listApplyDetail} from "@/api/purchase/purPlan";
import {filterAllByUser,selectByCode} from "@/api/system/invWarehouse";
import {filterSubByInv} from "@/api/system/invSubWarehouse";
import {getLocalJoinByUser} from "@/api/basic/busType";

export default {
    name: "idQuery",
    props: {
      pageType: {
        type: Object,
        required: true,
      },
        closeDialog: {
            type: Function,
            required: true,
        },
        idQuery: {
            type: Object,
            required: true,
        },
        editType: {
            type: Object,
            required: true,
        },
    },
    data() {
        return {
            code: "",
            query: {
                orderIdFk: "",
                page: 1,
                limit: 10,
            },
            formData: {
                id: null,
                billNo: null,
                createTime: "",
                remark: "",
                deptCode: null,
                locStorageCode: null,
                invWarehouseCode: null,
                auditRemark: null,
                autoPurchase: false,
                targetInv: 1000,
                targetSubInv: null,
                targetBillAction: null,
              pageType: null,
            },
          sysApprovalFlowConfig: false,
          approvalFlowDetailVisible: false,
            formRules: {},
            codeArray: [],
            total: 0,
            loading: false,
            index: null,
            formLoading: false,
            formVisible: false,
            deleteLoading: false,
            orderNo: null,
            statusMap: {
                1: "草稿",
                2: "未审核",
                3: "已审核",
                4: "拒绝",
            },
            typeMap: {
                1: "预入库",
                2: "普通采购",
            },
            orderEditor: true,
            sOptions: [],
            sValue: [],
            sList: [],
            sLoading: false,
            busTypes: [],
            currentRow: {},
            selectedIndex: "",
            selectProductVisible: false,
            thisData: {},
            subInvList: [],
            tarSubList: [],
            invQueryData: {},
            passLoading: false,
            noPassLoading: false,

        };
    },
    components: {
        draggable,
        purPlanProducts,
  approvalFlowDetail
    },
    methods: {
      getConfig(){
        getSysApprovalFlowConfig().then((response) => {
          this.sysApprovalFlowConfig = response.data;
        }).catch(() => {
        });
      },
      // closeDialog() {
      //   this.approvalFlowDetailVisible = false;
      // },
      handleClose() {
        this.approvalFlowDetailVisible = false;
      },
      showApprovalFlowDetail() {
        this.idQuery = this.formData
        this.approvalFlowDetailVisible = true;
      },
        saveOrder(status) {
            let tip = "";
            if (status == "3") {
                tip = "是否确定通过该采购计划？";
            } else {
                tip = "是否确定拒绝该采购计划？";
            }
            this.$confirm(tip, "提示", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning",
            }).then(() => {
              if (status == "3"){
                this.passLoading = true
              }else {
                this.noPassLoading = true
              }
                this.submitFunction(status);
            }).catch(() => {
              if (status == "3"){
                this.passLoading = false
              }else {
                this.noPassLoading = false
              }
            });
        },
        submitFunction(status) {
            let tMessage = status === '1' ? '保存' : '提交';
            this.loading = true;
            this.formData.pageType = this.pageType
            let tQuery = {
                autoPurchase:this.formData.autoPurchase,
                targetSubInv:this.formData.targetSubInv,
                targetDeptCode:this.formData.targetDeptCode,
                targetBillAction:this.formData.targetBillAction,
                editStatus: status,
                purPlanEntity: this.formData,
                subErpOrders: this.codeArray,
            }
            auditOrder(tQuery)
                .then(response => {
                  if (status == "3"){
                    this.passLoading = false
                  }else {
                    this.noPassLoading = false
                  }
                    // this.loading = false;
                    if (response.code === 20000) {
                        this.$message.success(tMessage + "成功");
                        this.closeDialog(true);
                    } else {
                        this.$message.error(response.message);
                    }
                })
                .catch(() => {
                  if (status == "3"){
                    this.passLoading = false
                  }else {
                    this.noPassLoading = false
                  }
                })
        },
        selectProductFunction() {
            this.selectProductVisible = true;
        },
        closeDialogC2(rData) {
            this.selectProductVisible = false;
            this.thisData = {};
            if (this.$isNotBlank(rData)) {
                this.codeArray = [];
                rData.forEach((obj, index) => {
                    this.codeArray.unshift(obj);
                });
                this.$refs.multipleTable.setCurrentRow(this.codeArray[0]);
                this.currentRow = this.codeArray[0];
                this.selectedIndex = 0;
            }
        },
        rowChange(val) {
            this.currentRow = val;
            this.selectedIndex = val.index;
        },
        tableCountChange(row) {
            if (this.$isNotBlank(row)) {
                // row.count = row.reCount;
            }
        },
        tableRowClassName({row, rowIndex}) {
            row.index = rowIndex;
        },
        // 刷新表单
        resetForm() {
            if (this.$refs["dataForm"]) {
                // 清空验证信息表单
                this.$refs["dataForm"].clearValidate();
                // 刷新表单
                this.$refs["dataForm"].resetFields();
                this.getList();
            }
        },
        deleteCodeArray(index, row) {
            this.$confirm("此操作将永久删除该数据, 是否继续?", "提示", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning",
            }).then(() => {
                this.$refs.multipleTable.setCurrentRow();
                this.currentRow = {};
                this.selectedIndex = "";

                if (this.orderEditor) {
                    this.detailLoading = true;
                    if (this.$isNotBlank(row.id)) {
                        delApplyDetail(row.id)
                            .then(response => {
                                this.detailLoading = false;
                                if (response.code === 20000) {
                                    this.$message.success(response.data);
                                    // this.getStockOrderDetailList();
                                    this.codeArray.splice(index, 1);
                                } else {
                                    this.$message.error(response.message);
                                }
                            })
                            .catch(() => {
                                this.detailLoading = false;
                            })
                    } else {
                        this.$message.success('删除成功');
                        this.codeArray.splice(index, 1);
                    }
                } else {
                    this.$message.success('删除成功');
                    this.codeArray.splice(index, 1);
                }
            }).catch(() => {

            });
        },
        getStockOrderDetailList() {
            this.loading = true;
            listApplyDetail(this.query) //查找该单号下的所有条码
                .then((response) => {
                    console.log(response)
                    this.codeArray = response.data.list || [];
                    this.total = response.data.total || 0;
                    this.loading = false;
                })
                .catch(() => {
                    this.loading = false;
                    this.list = [];
                    this.total = 0;
                });
        },
        findSubInvs() {
            this.subInvList = [];
            let query = {
                pcode: this.formData.locStorageCode
            };
            filterSubByInv(query)
                .then((response) => {
                    this.subInvList = response.data || [];
                    if (this.subInvList != null && this.subInvList.length == 1) {
                        this.formData.invWarehouseCode = this.subInvList[0].code;
                    }
                })
                .catch(() => {
                });
        },

        findTargetSubInvs() {
          if(this.formData.targetSubInv!=null && this.tarSubList.length>0){
            this.formData.targetDeptCode= this.subInvList.find(item => item.code == this.formData.targetSubInv).parentId
          }
          this.tarSubList = [];
            let query = {
                pcode: 1000
            };
            filterSubByInv(query)
                .then((response) => {
                    this.tarSubList = response.data || [];
                    if (this.tarSubList != null && this.tarSubList.length == 1) {
                        this.formData.targetSubInv = this.tarSubList[0].code;
                        this.formData.targetDeptCode=this.tarSubList[0].parentId;

                        this.targetInvChange();
                    }
                })
                .catch(() => {
                });
        },
        targetInvChange() {
            let query = {
                code: this.formData.targetSubInv,
                enabled: true,
                spUse: true,
            };
            getLocalJoinByUser(query)
                .then((response) => {
                    this.busTypes = response.data.list || [];
                    // this.formData.targetBillAction = this.busTypes[0].localAction;
                })
                .catch(() => {
                });
          let query1 = {
            code: this.formData.targetSubInv,
          };
          selectByCode(query1)
            .then((res) => {
              if (res.code === 20000) {
                this.formData.targetDeptCode=res.data
              }
            })
        },

    },
    filters: {},
    mounted() {
        document.body.ondrop = function (event) {
            event.preventDefault();
            event.stopPropagation();
        };
    },
    created() {
        if (this.$isNotBlank(this.idQuery.id)) {
            this.query.limit = 100;
            this.query.orderIdFk = this.idQuery.id;
            this.formData = this.idQuery.formData;
            this.formData.targetInv = 1000;
            this.orderEditor = true;
            this.sValue = this.formData.corpName;
            this.getStockOrderDetailList();
        } else {
            this.formData = {
                id: null,
                billNo: null,
                createTime: "",
                remark: "",
                deptCode: null,
                locStorageCode: null,
                invWarehouseCode: null,
                auditRemark: null,
                autoPurchase: false,
                targetInv: 1000,
                targetSubInv: null,
                targetBillAction: null,
            };
            this.orderEditor = false;
        }
        this.findTargetSubInvs();
        this.codeArray = [];
      this.getConfig();
    },
};
</script>
<style scoped>

.ao-text {
    width: 100%;
    font-size: 13px;
    font-family: "Microsoft YaHei";
    float: right;
    text-align: right;
    margin-top: 10px;
}

</style>



